jQuery(document).ready(function($){

	// Selectize - Post Types

	var post_types_options = [];

  	$.each(nnr_ab_data.post_types, function( index, value ) {
	  	post_types_options.push({id: index, name: value});


	  	// Load up all exlcude posts

	  	$.post(ajaxurl, {
		  	'action': 'nnr_ab_get_exclude_posts',
		  	'post_type': value,
	  	}, function(response) {

		  	// Selectize - Exclude Post Type

		  	response = $.parseJSON(response);

		  	var posts = [];

		  	$.each(response.posts, function( index, value ) {
		  		posts.push({id: value.ID, name: value.post_title});
		  	});

		  	$('#' + nnr_ab_data.prefix_dash + 'exclude-' + response.post_type).selectize({
				plugins: ['remove_button'],
				delimiter: ',',
				persist: false,
				valueField: 'id',
				labelField: 'name',
				searchField: 'name',
				options: posts,
			});
		});

	});

	$('#' + nnr_ab_data.prefix_dash + 'post-types').selectize({
		plugins: ['remove_button'],
		delimiter: ',',
		persist: false,
		valueField: 'id',
		labelField: 'name',
		searchField: 'name',
		options: post_types_options,
	});

	// Color Picker

	$('.' + nnr_ab_data.prefix_dash + 'colorpicker').wpColorPicker();

	// Hide and show settings

/*
	$('.' + nnr_ab_data.prefix_dash + 'shortcode').hide();

	if ( $('.' + nnr_ab_data.prefix_dash + 'location').val() == 'other' ) {
		$('.' + nnr_ab_data.prefix_dash + 'shortcode').show();
	}

	$('.' + nnr_ab_data.prefix_dash + 'location').change(function(){
		$('.' + nnr_ab_data.prefix_dash + 'shortcode').hide();

		if ( $(this).val() == 'other' ) {
			$('.' + nnr_ab_data.prefix_dash + 'shortcode').show();
		}
	});
*/

	// Define the variables

	var license_activate_button = '<span class="btn btn-primary ' +
		nnr_ab_data.prefix_dash + 'activate-license">' +
		nnr_ab_data.activate_text + '</span>';

	var license_deactivate_button = '<span class="btn btn-default ' +
		nnr_ab_data.prefix_dash + 'deactivate-license">' +
		nnr_ab_data.deactivate_text + '</span>';

	var check = '<span class="fa fa-check form-control-feedback" aria-hidden="true"></span>';
	var error = '<span class="fa fa-times form-control-feedback" aria-hidden="true"></span>';
	var spinner = '<i class="' + nnr_ab_data.prefix_dash + 'license-key-status fa fa-spinner fa-spin form-control-feedback"></i>';

	// Check license key

	if ( $('.' + nnr_ab_data.prefix_dash + 'license-key').val() != '' ) {

		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(spinner);

		var data = {
			'action': 'nnr_ab_license_action',
			'license_action': 'check_license',
			'license_key': $('.' + nnr_ab_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
			$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
			$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

			if ( response == 'valid' ) {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').addClass(nnr_ab_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_deactivate_button);
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.activation_valid + '</em>');

			}  else if ( response == 'expired' ) {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').addClass(nnr_ab_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.expired + '</em>');

			} else {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').addClass(nnr_ab_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.activation_error + '</em>');

			}

			console.log(response);
		});
	} else {
		$('.' + nnr_ab_data.prefix_dash + 'license-key').addClass(nnr_ab_data.prefix_dash + 'license-key-valid');
		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(error);
		$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-error');

		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.no_license_key + '</em>');
	}

	// Activate License

	$(document).on('click', '.' + nnr_ab_data.prefix_dash + 'activate-license', function(){

		$('.' + nnr_ab_data.prefix_dash + 'activation-message').remove();
		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(spinner);
		$('.' + nnr_ab_data.prefix_dash + 'activate-license').remove();
		$('.' + nnr_ab_data.prefix_dash + 'deactivate-license').remove();
		$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
		$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

		var data = {
			'action': 'nnr_ab_license_action',
			'license_action': 'activate_license',
			'license_key': $('.' + nnr_ab_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();

			if ( response == 'valid' ) {

				$('.alert').remove();

				$('.' + nnr_ab_data.prefix_dash + 'license-key').addClass(nnr_ab_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_deactivate_button);
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.activation_valid + '</em>');

			} else {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').addClass(nnr_ab_data.prefix_dash + 'license-key-valid');
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(error);
				$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-error');

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.activation_error + '</em>');

			}

			console.log(response);
		});

	});

	// Deactivate License

	$(document).on('click', '.' + nnr_ab_data.prefix_dash + 'deactivate-license', function(){

		$('.' + nnr_ab_data.prefix_dash + 'activation-message').remove();
		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();
		$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(spinner);
		$('.' + nnr_ab_data.prefix_dash + 'activate-license').remove();
		$('.' + nnr_ab_data.prefix_dash + 'deactivate-license').remove();
		$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').removeClass('has-success');
		$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').removeClass('has-error');

		var data = {
			'action': 'nnr_ab_license_action',
			'license_action': 'deactivate_license',
			'license_key': $('.' + nnr_ab_data.prefix_dash + 'license-key').val(),
		};

		$.post(ajaxurl, data, function(response) {

			$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().find('.fa').remove();

			if ( response == 'deactivated' ) {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').val('');
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append(license_activate_button);
				///$('.' + nnr_ab_data.prefix_dash + 'license-key-feedback').addClass('has-success');

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().append(check);
				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.deactivation_valid + '</em>');

			} else if ( response == 'failed' ) {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.deactivation_error + '</em>');

			} else {

				$('.' + nnr_ab_data.prefix_dash + 'license-key').parent().parent().append('<em class="help-block ' + nnr_ab_data.prefix_dash + 'activation-message">' + nnr_ab_data.deactivation_error + '</em>');
			}

			console.log(response);
		});

	});

});